#!/bin/bash

if [ $# -ne 1 ]
then
    echo " Expecting log-directory!"
    exit 1
fi

DIR=$1
echo "dir is $DIR"
SIZE=`find $DIR -name "*err*" | wc -l`
echo "size is $SIZE"

TOTALUNIVVARS=`grep "univ vars num vars:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTVARS=`grep "exist vars num vars:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALUNIVCLASSES=`grep "univ vars num classes:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTCLASSES=`grep "exist vars num classes:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTCLASSESPEREXISTVARS=`grep "exist classes per exist vars:" $DIR/*.err | awk '{sum+=$6}END{print sum}'`
TOTALUNIVCLASSESPERUNIVVARS=`grep "univ classes per univ vars:" $DIR/*.err | awk '{sum+=$6}END{print sum}'`
TOTALUNIVH=`grep "univ vars num h:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTH=`grep "exist vars num h:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTPTRS=`grep "exist vars num ptrs:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALUNIVHSUCC=`grep "univ vars num h succ:" $DIR/*.err | awk '{sum+=$6}END{print sum}'`
TOTALEXISTHSUCC=`grep "exist vars num h succ:" $DIR/*.err | awk '{sum+=$6}END{print sum}'`
TOTALUNIVDEPS=`grep "univ vars num deps:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALEXISTDEPS=`grep "exist vars num deps:" $DIR/*.err | awk '{sum+=$5}END{print sum}'`
TOTALUNIVRATIOHSUCCPERDEPS=`grep "univ vars summed ratio h succ per deps:" $DIR/*.err | awk '{sum+=$9}END{print sum}'`
TOTALEXISTRATIOINPTRSPERDEPS=`grep "exist vars summed ratio in ptrs per deps:" $DIR/*.err | awk '{sum+=$9}END{printf("%ld\n", sum)}'`
TOTALEXISTRATIODEPSCLASSESPERDEPS=`grep "exist vars summed ratio deps classes per deps:" $DIR/*.err | awk '{sum+=$9}END{printf("%ld\n", sum)}'`
MAXUNIVH=`grep "univ vars max h:" $DIR/*.err | awk '{print $5}' | sort -n | tail -n 1`
MAXEXISTH=`grep "exist vars max h:" $DIR/*.err | awk '{print $5}' | sort -n | tail -n 1`
MAXUNIVHSUCC=`grep "univ vars max h succ:" $DIR/*.err | awk '{print $6}' | sort -n | tail -n 1`
MAXEXISTHSUCC=`grep "exist vars max h succ:" $DIR/*.err | awk '{print $6}' | sort -n | tail -n 1`
MAXUNIVDEPS=`grep "univ vars max deps:" $DIR/*.err | awk '{print $5}' | sort -n | tail -n 1`
MAXEXISTDEPS=`grep "exist vars max deps:" $DIR/*.err | awk '{print $5}' | sort -n | tail -n 1`
MAXEXISTPTRS=`grep "exist vars max ptrs:" $DIR/*.err | awk '{print $5}' | sort -n | tail -n 1`

AVGUNIVH=`echo "scale=4; $TOTALUNIVH/$TOTALUNIVVARS" | bc`
AVGEXISTH=`echo "scale=4; $TOTALEXISTH/$TOTALEXISTVARS" | bc`
AVGUNIVHSUCC=`echo "scale=4; $TOTALUNIVHSUCC/$TOTALUNIVVARS" | bc`
AVGEXISTHSUCC=`echo "scale=4; $TOTALEXISTHSUCC/$TOTALEXISTVARS" | bc`
AVGUNIVDEPS=`echo "scale=4; $TOTALUNIVDEPS/$TOTALUNIVVARS" | bc`
AVGEXISTDEPS=`echo "scale=4; $TOTALEXISTDEPS/$TOTALEXISTVARS" | bc`
AVGEXISTPTRS=`echo "scale=4; $TOTALEXISTPTRS/$TOTALEXISTVARS" | bc`
AVGUNIVRATIOHSUCCPERDEPS=`echo "scale=4; $TOTALUNIVRATIOHSUCCPERDEPS/$TOTALUNIVVARS" | bc`
AVGEXISTRATIOINPTRSPERDEPS=`echo "scale=4; $TOTALEXISTRATIOINPTRSPERDEPS/$TOTALEXISTVARS" | bc`
AVGEXISTRATIODEPSCLASSESPERDEPS=`echo "scale=4; $TOTALEXISTRATIODEPSCLASSESPERDEPS/$TOTALEXISTVARS" | bc`
AVGEXISTCLASSESPEREXISTVARS=`echo "scale=4; $TOTALEXISTCLASSESPEREXISTVARS/$SIZE" | bc`
AVGUNIVCLASSESPERUNIVVARS=`echo "scale=4; $TOTALUNIVCLASSESPERUNIVVARS/$SIZE" | bc`

echo "total univ vars: $TOTALUNIVVARS"
echo "total exist vars: $TOTALEXISTVARS"
echo "total univ classes: $TOTALUNIVCLASSES"
echo "total exist classes: $TOTALEXISTCLASSES"
echo "total exist classes per exist vars: $TOTALEXISTCLASSESPEREXISTVARS"
echo "total univ classes per univ vars: $TOTALUNIVCLASSESPERUNIVVARS"
echo "total univ h: $TOTALUNIVH"
echo "total exist h: $TOTALEXISTH"
echo "total exist ptrs: $TOTALEXISTPTRS"
echo "total univ h succ: $TOTALUNIVHSUCC"
echo "total exist h succ: $TOTALEXISTHSUCC"
echo "total univ deps: $TOTALUNIVDEPS"
echo "total exist deps: $TOTALEXISTDEPS"
echo "total univ ratio h succ per deps: $TOTALUNIVRATIOHSUCCPERDEPS"
echo "total exist ratio in ptrs per deps: $TOTALEXISTRATIOINPTRSPERDEPS"
echo "max univ h: $MAXUNIVH"
echo "max exist h: $MAXEXISTH"
echo "max univ h succ: $MAXUNIVHSUCC"
echo "max exist h succ: $MAXEXISTHSUCC"
echo "max univ deps: $MAXUNIVDEPS"
echo "max exist deps: $MAXEXISTDEPS"
echo "max exist ptrs: $MAXEXISTPTRS"

echo "avg univ h: $AVGUNIVH"
echo "avg exist h: $AVGEXISTH"
echo "avg univ h succ: $AVGUNIVHSUCC"
echo "avg exist h succ: $AVGEXISTHSUCC"
echo "avg univ deps: $AVGUNIVDEPS"
echo "avg exist deps: $AVGEXISTDEPS"
echo "avg exist ptrs: $AVGEXISTPTRS"
echo "avg univ ratio h succ per deps: $AVGUNIVRATIOHSUCCPERDEPS"
echo "avg exist ratio in ptrs per deps: $AVGEXISTRATIOINPTRSPERDEPS"
echo "avg exist ratio deps classes per deps: $AVGEXISTRATIODEPSCLASSESPERDEPS"
echo "avg exist classes per exist vars: $AVGEXISTCLASSESPEREXISTVARS"
echo "avg univ classes per univ vars: $AVGUNIVCLASSESPERUNIVVARS"
